﻿// Keep this lines for a best effort IntelliSense of Visual Studio 2017.
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Lib\jquery.d.ts" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\TcHmi.d.ts" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Controls\System\TcHmiControl\Source.d.ts" />

// Keep this lines for a best effort IntelliSense of Visual Studio 2013/2015.
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Lib\jquery\jquery.js" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\TcHmi.js" />

/*
 * Generated 5/8/2019 2:55:09 PM
 * Copyright TimH 2019
 * 
 * destinationdirectory:        C:\Users\TimH\Source\Repos\TcHmiProject50\FrameworkControlJs1
 * TcHmi_DefaultParameters:     [$guid1$, 512b33ca-b497-48ad-96d2-1cd1a4732bb3] | [$guid2$, 26ae1eac-ee42-4b05-9f84-3b1328a29b4f] | [$guid3$, d1c4d555-e250-4c88-ab4f-1581c7c43f82] | [$guid4$, ba16df8a-7ba5-462d-8fd2-1959f77ec9c3] | [$guid5$, 682a23c9-8115-47be-b2ab-42ce4fb26af3] | [$guid6$, 9ac22e92-09a6-48fe-b690-9f9ddbbca82b] | [$guid7$, ca234b16-bf0b-45f7-a330-c77febe7bb44] | [$guid8$, 87806fa8-7ef0-4569-bf3e-3bb840d3e6fe] | [$guid9$, 662e9128-f5da-4a8a-b9ef-c65e7d5f482b] | [$guid10$, 01b3f473-8500-473e-b6c7-4dd41da62a36] | [$time$, 5/8/2019 2:55:09 PM] | [$year$, 2019] | [$username$, TimH] | [$userdomain$, BECKHOFF] | [$machinename$, TIMH-NB02] | [$clrversion$, 4.0.30319.42000] | [$registeredorganization$, ] | [$runsilent$, False] | [$solutiondirectory$, C:\Users\TimH\Source\Repos\TcHmiProject50\] | [$projectname$, FrameworkControlJs1] | [$safeprojectname$, FrameworkControlJs1] | [$currentuiculturename$, en-US] | [$installpath$, C:\Program Files (x86)\Microsoft Visual Studio\2017\Professional\Common7\IDE\] | [$specifiedsolutionname$, FrameworkControlJs1] | [$exclusiveproject$, False] | [$destinationdirectory$, C:\Users\TimH\Source\Repos\TcHmiProject50\FrameworkControlJs1] | [$targetframeworkversion$, 4.5]
 * projectname_tchmi:           FrameworkControlJs1
 * projectname_tchmi_dashcase:  framework-control-js1
 * safeprojectname:             FrameworkControlJs1
 * projectname:                 FrameworkControlJs1
 */

/**
*  Namespace: TcHmi
*  [REQUIRED]
*/
(function (TcHmi) {
    /**
    *  Namespace: TcHmi.Controls
    *  [REQUIRED]
    */
    (function (Controls) {
        /**
         *  Namespace: TcHmi.Controls.Custom
         *  [CUSTOM]
         */
        var Custom;
        (function (Custom) {
            /** FrameworkControlJs1 object */
            var FrameworkControlJs1 = (function (_super) {
                __extends(FrameworkControlJs1, _super);

                /*
                Attribute philosophy
                --------------------
                - Local variables are not set while definition in class, so they have the value 'undefined'.
                - On compile the Framework sets the value from HTML or from theme (possibly 'null') via normal setters
                - The "changed detection" in the setter will result in processing the value only once while compile
                - Attention: If we have a Server Binding on an Attribute the setter can be very late or never (leaving the value = undefined).
                */
                
                /**
                 * @description Constructor of the control
                 * @param {JQuery} element Element from HTML (internal, do not use)
                 * @param {JQuery} pcElement precompiled Element (internal, do not use)
                 * @param {TcHmi.Controls.ControlAttributeList} attrs Attributes defined in HTML in a special format (internal, do not use)
                 * @returns {void}
                 */
                function FrameworkControlJs1(element, pcElement, attrs) {
                    /** Call base constructor */
                    _super.call(this, element, pcElement, attrs);                      

                    // member variable for myCustomDatatype
                    this.__myCustomDatatype = undefined;

                    // create a new array for all object resolvers
                    this.__objectResolvers = new Map();                        
                }
                /** 
                * @description Is called during control initialize phase before attribute setter are called based on initial html dom values. 
                * @returns {void}
                */
                FrameworkControlJs1.prototype.__previnit = function () {
                    /** Handle template elements. Should be done before call to __previnit of super class. */
                    this.__elementTemplateRoot = this.__element.find('.framework-control-js1-template');
                    this.__elementShowValue = this.__elementTemplateRoot.find('.framework-control-js1-value');
                    
                    /** Call __previnit of super class with the correct instance. */
                    _super.prototype.__previnit.call(this);
                };
                /** 
                 * @description Is called during control initialize phase after attribute setter have been called based on it's default or initial html dom values. 
                 * @returns {void}
                 */
                FrameworkControlJs1.prototype.__init = function () {
                    /** Call __init of super class with the correct instance. */
                    _super.prototype.__init.call(this);

                };
                /**
                * @description Is called after the control instance gets part of the current DOM.
                * Is only allowed to be called from the framework itself!
                * @returns {void}
                */
                FrameworkControlJs1.prototype.__attach = function () {
                    /** Call __attach of super class with the correct instance. */
                    _super.prototype.__attach.call(this);

                    /**
                     * Initialize everything which is only available while the control is part of the active dom.
                     */

                    // start watch of all object resolvers
                    this.__objectResolvers.forEach(function (resolverInfo) {
                        return resolverInfo.resolver.watch(resolverInfo.watchCallback);
                    });
                };
                /**
                * @description Is called after the control instance is no longer part of the current DOM.
                * Is only allowed to be called from the framework itself!
                * @returns {void}
                */
                FrameworkControlJs1.prototype.__detach = function () {
                    /** Call __detach of super class with the correct instance. */
                    _super.prototype.__detach.call(this);

                    /**
                     * Disable everything which is not needed while the control is not part of the active dom.
                     * No need to listen to events for example!
                     */

                    // destroy all object resolvers
                    this.__objectResolvers.forEach(function (resolverInfo) {
                        if (resolverInfo.watchDestroyer) {
                            resolverInfo.watchDestroyer();
                            resolverInfo.watchDestroyer = null;
                        }
                    });
                };
                /**
                * @description Destroy the current control instance. 
                * Will be called automatically if system destroys control!
                * @returns {void}
                */
                FrameworkControlJs1.prototype.destroy = function () {
                    /** Call destroy of super class with the correct instance. */
                    _super.prototype.destroy.call(this);

                    /**
                    * Free resources like child controls etc.
                    */

                    // destroy all object resolvers
                    this.__objectResolvers.forEach(function (resolverInfo) {
                        if (resolverInfo.watchDestroyer) {
                            resolverInfo.watchDestroyer();
                        }
                        resolverInfo.resolver.destroy();
                    });
                    // clear object resolver array
                    this.__objectResolvers.clear();
                };

                /**
                * @description Setter function for 'data-tchmi-my-custom-datatype' attribute.
                * @param {Boolean} valueNew the new value or null
                * @returns {void}
                */
                FrameworkControlJs1.prototype.setMyCustomDatatype = function (valueNew) {
                    // convert the value with the value converter
                    var convertedValue = TcHmi.ValueConverter.toObject(valueNew);

                    // check if the converted value is valid
                    if (convertedValue === null) {
                        // if we have no value to set we have to fall back to the defaultValueInternal from description.json
                        convertedValue = this.getAttributeDefaultValueInternal('MyCustomDatatype');
                    }       

                    // check if there is an exisitng resolver
                    var resolverInfo = this.__objectResolvers.get('MyCustomDatatype');

                    // destroy exisiting resolver if it already exists
                    if (resolverInfo) {
                        if (resolverInfo.watchDestroyer) {
                            resolverInfo.watchDestroyer();
                        }
                        resolverInfo.resolver.destroy();
                    }

                    // create a new object resolver
                    var resolver = new TcHmi.Symbol.ObjectResolver(convertedValue);

                    // reference to object resolver callback
                    // this function will be called if the values of the symbols changes
                    let cb = this.__onResolverForMyCustomDatatypeWatchCallback();

                    // create object resolver for MyCustomDatatype
                    this.__objectResolvers.set('MyCustomDatatype', {
                        resolver: resolver,
                        watchCallback: cb,
                        watchDestroyer: resolver.watch(cb)
                    });
                };

                /**
				* The watch callback for the MyCustomDatatype object resolver.
				*/
                FrameworkControlJs1.prototype.__onResolverForMyCustomDatatypeWatchCallback = function () {
                    // get control reference
                    var $this = this;
                    return function (data) {
                        // While not attached attribute should only be processed once during initializing phase.
                        if ($this.__isAttached === false && data.destroy) { 
                            data.destroy();
                        }

                        // check if there is a change in the data object
                        if (tchmi_equal(data.value, $this.__myCustomDatatype)) {
                            return;
                        }

                        // proceed with new data object
                        $this.__myCustomDatatype = data.value;

                        // verify if data object is an array or not
                        if (Array.isArray(data.value)) {
                            $this.__myCustomDatatype = data.value;
                        }
                        else {
                            $this.__myCustomDatatype = [data.value];
                        }

                        // inform the system that the values has changed
                        TcHmi.EventProvider.raise($this.__id + '.onFunctionResultChanged', ['getMyCustomDatatype']);

                        // process with the new data object
                        $this.__processMyCustomDatatype();
                    }
                }

                /**
                * @description Getter function for 'data-tchmi-my-custom-datatype' attribute.
                * @returns {Boolean}
                */
                FrameworkControlJs1.prototype.getMyCustomDatatype = function () {
                    return this.__myCustomDatatype;
                };

                /**
                * @description Processor function for 'data-tchmi-my-custom-datatype' attribute.
                * @returns {void}
                */
                FrameworkControlJs1.prototype.__processMyCustomDatatype = function () {
                    // process actions with Value
                    //...

                    // sample: display result on screen
                    var output = "";
                   
                    for (var i = 0; i < this.__myCustomDatatype.length; i++) {                        
                        output += "Value " + i + ": " + this.__myCustomDatatype[i].value + "; ";                        
                    }

                    this.__elementShowValue.text(output);
                };

                return FrameworkControlJs1;
            })(TcHmi.Controls.System.TcHmiControl);
            Custom.FrameworkControlJs1 = FrameworkControlJs1;
        })(Custom = Controls.Custom || (Controls.Custom = {}));
        /**
        * Register control...
        */
        Controls.register('framework-control-js1', Custom.FrameworkControlJs1, 'Custom/FrameworkControlJs1/', 'Custom/FrameworkControlJs1/Template.html');
    })(Controls = TcHmi.Controls || (TcHmi.Controls = {}));
})(TcHmi);